#include <stdio.h>
#include "sparsesd.h"

int main()
{
  /* make test case */
  integer maxprs = 2;
  integer lanmax = 5;
  integer lohi = 0;
  integer j, neig, ierr, msglvl, info, i, k;
  doublereal *ritz = malloc(lanmax*sizeof(doublereal));
  doublereal *bnd = malloc(lanmax*sizeof(doublereal));
  doublecomplex *vec = malloc(10*maxprs*sizeof(doublecomplex));
  doublecomplex *dense;
  int row,col;
  int info2;
  elslist els;
  integer job = 1; /* return eigenvectors 0=no 1=reduced 2=full */
  msglvl = 0;
  j = 0;
  neig = 0;
  ierr = 0;
  info = 0;
  info2 = 0;
  for(i=0;i<lanmax;i++){
    ritz[i]=0;
    bnd[i]=0;
  }
  for(i=0;i<10*maxprs;i++){
    vec[i].re=0;
    vec[i].im=0;
  }

  els.n = 10;
  els.c = malloc(21*sizeof(*els.c));
  els.r = NULL;
  els.i = malloc(21*sizeof(*els.i));
  els.j = malloc((els.n+1)*sizeof(*els.j));
  els.inner = malloc(els.n*sizeof(*els.inner));

  els.c[0].re=1;
  els.c[0].im=0;
  els.c[1].re=2;
  els.c[1].im=0;
  els.c[2].re=4;
  els.c[2].im=0;
  els.c[3].re=1;
  els.c[3].im=0;
  els.c[4].re=3;
  els.c[4].im=0;
  els.c[5].re=6;
  els.c[5].im=0;
  els.c[6].re=4;
  els.c[6].im=0;
  els.c[7].re=3;
  els.c[7].im=0;
  els.c[8].re=5;
  els.c[8].im=0;
  els.c[9].re=7;
  els.c[9].im=0;
  els.c[10].re=2;
  els.c[10].im=0;
  els.c[11].re=4;
  els.c[11].im=0;
  els.c[12].re=-6;
  els.c[12].im=0;
  els.c[13].re=3;
  els.c[13].im=0;
  els.c[14].re=2;
  els.c[14].im=0;
  els.c[15].re=-1;
  els.c[15].im=0;
  els.c[16].re=-4;
  els.c[16].im=0;
  els.c[17].re=8;
  els.c[17].im=0;
  els.c[18].re=1;
  els.c[18].im=0;
  els.c[19].re=9;
  els.c[19].im=0;
  els.c[20].re=10;
  els.c[20].im=0;

  els.i[0]=0;
  els.i[1]=1;
  els.i[2]=3;
  els.i[3]=8;
  els.i[4]=2;
  els.i[5]=5;
  els.i[6]=7;
  els.i[7]=2;
  els.i[8]=4;
  els.i[9]=6;
  els.i[10]=9;
  els.i[11]=3;
  els.i[12]=5;
  els.i[13]=7;
  els.i[14]=6;
  els.i[15]=7;
  els.i[16]=7;
  els.i[17]=7;
  els.i[18]=8;
  els.i[19]=8;
  els.i[20]=9;
                                         
  els.j[0]=0;
  els.j[1]=4;
  els.j[2]=7;
  els.j[3]=11;
  els.j[4]=14;
  els.j[5]=16;
  els.j[6]=16;
  els.j[7]=17;
  els.j[8]=19;
  els.j[9]=20;
  els.j[10]=21;

  els.inner[0]=1;
  els.inner[1]=0;
  els.inner[2]=0;
  els.inner[3]=1;
  els.inner[4]=0;
  els.inner[5]=0;
  els.inner[6]=1;
  els.inner[7]=0;
  els.inner[8]=1;
  els.inner[9]=1;

  /* reconstruct dense matrix for printing */

  dense=malloc(els.n*els.n*sizeof(*dense));
  for(i=0; i<els.n*els.n; i++){dense[i].re=0.0;dense[i].im=0.0;}
  for(row=0; row<els.n; row++)
    for(col=els.j[row]; col<els.j[row+1]; col++){
      dense[row+els.n*els.i[col]].re=els.c[col].re;
      dense[row+els.n*els.i[col]].im=els.c[col].im;
      if(row!=els.i[col]){
	dense[row*els.n+els.i[col]].re=els.c[col].re;
	dense[row*els.n+els.i[col]].im=-els.c[col].im;
      }
    }
  printf("mat={{");
  for(row=0; row<els.n; row++){
    for(col=0; col<els.n; col++)
      printf("%s %g%+g*I",col?",":"",
	     dense[row+els.n*col].re,dense[row+els.n*col].im);
    printf("}%s",row<els.n-1?",\n   {":"};\n");
  }
  free(dense);
  printf("ee={");
  for(row=0; row<els.n; row++)
      printf("%s %g",row?",":"",els.inner[row]);
  printf("};\n");

  /* now actually solve the eigenvalue problem */

  speigprob(&els, maxprs, lanmax, lohi, &j, &neig, ritz, bnd,
	    job, vec, msglvl, &ierr, &info, &info2);

  printf("\nEigenvalues:\n");
  for(i = 0; i < maxprs; i++)
    printf("%f\t%f\n", ritz[i], bnd[i]);
  printf("\nerrorflag(should be 1):\t\t%d\n",(int) info2);
  printf("number of eigenvalues found:\t%d\n",(int) neig);
  printf("\nEigenvectors:\n");
  for(i = 0; i < maxprs; i++) {
    printf("#%d:\n",(int) i);
    for(k = 0; k < 10; k++)
      printf("%f + %f I\n",vec[10*i+k].re,vec[10*i+k].im);
  }

  free(els.inner);
  free(ritz);
  free(bnd);
  free(vec);
  return 0;
}
